Attribute VB_Name = "modCommon"
'VB-Amp Pro Common Code
'======================
' These are routines used by the other forms. There are common
' filename manipulation and low-level API calling routines.
' This code also contains the definitions for structures used
' by the API's etc, and declarations for common/public variables
' (such as preference options).
'
'Additional code submitted personally:
'* Tnatsni (tnatsni@usa.net):
'   - Snap2ViewPoint, AlwaysOnTop, GetRealEstate
'* zumzumz@hotmail.com:
'   - Volume API calling/variable conversion help
'
'Code found on the web and incorporated:
'* Ben Baird <psyborg@cyberhighway.com>:
'   - NotifyIcon, stuff for system tray icon and menu
'---------------------------------------------------------------

'Option Explicit

Public Const SPI_GETWORKAREA& = 48
Public Const WM_MOUSEMOVE = &H200
Public Const NIF_ICON = &H2
Public Const NIF_MESSAGE = &H1
Public Const NIF_TIP = &H4
Public Const NIM_ADD = &H0
Public Const NIM_DELETE = &H2
Public Const MAX_TOOLTIP As Integer = 64
Public Const BIF_RETURNONLYFSDIRS = &H1
Public Const MIXER_SHORT_NAME_CHARS = 16
Public Const MIXER_LONG_NAME_CHARS = 64

'Used for tray icon
Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * MAX_TOOLTIP
End Type

'Used for screen functions
Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'Used for browsing directories
Public Type SHITEMID
  cb      As Long
  abID    As Byte
End Type

'Used for browsing directories
Public Type ITEMIDLIST
  mkid    As SHITEMID
End Type

'Used for browsing directories
Public Type BROWSEINFO
  hOwner          As Long
  pidlRoot        As Long
  pszDisplayName  As String
  lpszTitle       As String
  ulFlags         As Long
  lpfn            As Long
  lParam          As Long
  iImage          As Long
End Type

'Used for region points
Type Coord
  X As Long
  Y As Long
End Type

'Used to store extended coordinate info for skin elements
Type DEx
  X  As Integer 'source
  Y  As Integer
  W  As Integer
  H  As Integer
  X2 As Integer 'dest
  Y2 As Integer
  W2 As Integer
  H2 As Integer
  G  As Integer 'graphic format
  S  As Integer 'spacing
  F  As Integer 'format
  V  As Single  'value of slider
End Type

' Used for Volume Control
Type lVolType
  V As Long
End Type

Type VolType
  LV As Integer
  RV As Integer
End Type

' Used to Hold MP3 Info Tag
Type IDTag
    Title As String * 30
    Artist As String * 30
    Album As String * 30
    Year As String * 4
    Comment As String * 29
    Track As String * 1 'ID3v1.1 format
    Genre As String * 1
End Type

' Used for transparent bitmaps
Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type


Public Prg As String, Sect As String

Public StartTime As Single, MaxTime As Single
Public Reg_Name As String, Reg_Code As String
Public InActCnt As Integer, Balance As Single

Public OptDefPath As String
Public OptCardType As Integer, OptCardPort As Integer
Public OptAlwaysOnTop As Integer, OptSnap As Integer
Public OptAuto As Integer, OptSnooze As Integer, OptSnoozeMd As Integer
Public SnoozeTm As Integer, OptSnoozeAt As String, OptMinOnSnz As Integer
Public OptSkinName As String, OptSkinPath As String, OptSavePos As Integer
Public OptExitMd As Integer, OptStartMd As Integer, OptValExt As String
Public OptStartMin As Integer, OptStartMute As Integer
Public OptStartFile As String, OptVisPLPath As String
Public OptTimeFmt As Integer, OptClrPl As Integer, OptUseTagCover As Integer
Public OptAutoPlay As Integer, OptPBOverlap As Integer, OptFriendly As Integer
Public OptSkinImport As String, OptScrollName As Integer
Public SkinInfo As String, InfoTag As IDTag

Public nfIconData As NOTIFYICONDATA

'System tray functions
Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long
Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, lpvParam As Any, ByVal fuWinIni As Long) As Long

'Directory browsing functions
Public Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long
Public Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long

'Window Region declares
Public Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Public Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As Coord, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Public Declare Function CreatePolyPolygonRgn Lib "gdi32" (lpPoint As Coord, lpPolyCounts As Long, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Public Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long

'Transparent form support functions
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Public Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long

'Mixer functions
Declare Function waveOutSetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, ByVal dwVolume As Long) As Long
Declare Function waveOutGetVolume Lib "winmm.dll" (ByVal uDeviceID As Long, lpdwVolume As Long) As Long

'Popup menu functions
Declare Function TrackPopupMenu Lib "user32" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal X As Long, ByVal Y As Long, ByVal nReserved As Long, ByVal hwnd As Long, lpReserved As Any) As Long
Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
'

'Sets the specified form to be on top or not
Public Sub AlwaysOnTop(frmForm As Form, fOnTop)
        
    Const HWND_TOPMOST = -1
    Const HWND_NOTOPMOST = -2
        
    Dim lState As Long
    Dim iLeft As Integer, iTop As Integer, iWidth As Integer, iHeight As Integer
    
    With frmForm
        iLeft = .Left / Screen.TwipsPerPixelX
        iTop = .Top / Screen.TwipsPerPixelY
        iWidth = .Width / Screen.TwipsPerPixelX
        iHeight = .Height / Screen.TwipsPerPixelY
    End With
        
    If fOnTop Then
        lState = HWND_TOPMOST
    Else
        lState = HWND_NOTOPMOST
    End If
    Call SetWindowPos(frmForm.hwnd, lState, iLeft, iTop, iWidth, iHeight, 0)
    
End Sub

'Snaps form to edges of screen area
Sub Snap2ViewPoint(ThaForm As Form)
   Dim RC As RECT, Zone As Integer
    
    RC = GetRealEstate
    Zone = 240
    
    'Snap Main Window to Viewpoint
    If OptSnap Then
        If (ThaForm.Top > -Zone) And (ThaForm.Top < Zone) Then ThaForm.Top = 0
        If (ThaForm.Left > -Zone) And (ThaForm.Left < Zone) Then ThaForm.Left = 0
        If (ThaForm.Top + ThaForm.Height > RC.Bottom - Zone) And (ThaForm.Top + ThaForm.Height < RC.Bottom + Zone) Then ThaForm.Top = RC.Bottom - ThaForm.Height - 15
        If (ThaForm.Left + ThaForm.Width > RC.Right - Zone) And (ThaForm.Left + ThaForm.Width < RC.Right + Zone) Then ThaForm.Left = RC.Right - ThaForm.Width
    End If
End Sub

'Find the desktop size
Public Function GetRealEstate() As RECT
    Dim RC As RECT
    Dim R As Long
    Dim Msg As String
    
    R = SystemParametersInfo(SPI_GETWORKAREA, 0&, RC, 0&)

    RC.Left = RC.Left * Screen.TwipsPerPixelX
    RC.Top = RC.Top * Screen.TwipsPerPixelY
    RC.Right = RC.Right * Screen.TwipsPerPixelX
    RC.Bottom = RC.Bottom * Screen.TwipsPerPixelY

    GetRealEstate = RC

End Function

'Determines if the filename is a supported bitmap file
Public Function IsPic(F As String) As Boolean
    Dim X As String
    
    X = UCase$(Right$(F, 4))
    If X = ".BMP" Or X = ".GIF" Or X = ".JPG" Then
      IsPic = True
    Else
      IsPic = False
    End If
End Function

Public Function FindCover(ByVal F As String) As String
    Dim A As String, Ext As String
    
    F = Trim$(F)
    A = ""
    Ext = ".BMP": GoSub TestIt
    Ext = ".GIF": GoSub TestIt
    Ext = ".JPG": GoSub TestIt
        
    FindCover = A
    Exit Function
  
TestIt:
    If Exists(F & Ext) = True Then A = F & Ext
    Return
 
End Function

'Gets the wave out volume from 0% to 100% (ignores balance control)
Public Function GetVol() As Single
    Dim lVol As lVolType, Vol As VolType, LV As Double, RV As Double
    
    waveOutGetVolume 0, V    'read the current value
    
    lVol.V = V
    LSet Vol = lVol
    LV = Vol.LV: If LV < 0 Then LV = 65535 + LV
    RV = Vol.RV: If RV < 0 Then RV = 65535 + RV
    If RV > LV Then LV = RV
    
    GetVol = LV / 65535 'Convert to percent
    
End Function

'Sets the wave out volume from 0 to 1 (uses balance 0 to 1)
Public Sub SetVol(Pct As Single)
    Dim lVol As lVolType, Vol As VolType, LV As Double, RV As Double
    Dim LB As Single, RB As Single
    
    RB = 1: If Balance < 0.45 Then RB = 1 - (0.5 - Balance) * 2 'Right Balance
    LB = 1: If Balance > 0.55 Then LB = 1 - (Balance - 0.5) * 2 'Left Balance
    
    LV = Pct * 65535 * LB: If LV > 32767 Then LV = LV - 65536
    RV = Pct * 65535 * RB: If RV > 32767 Then RV = RV - 65536
    Vol.LV = LV
    Vol.RV = RV
    LSet lVol = Vol
    V = lVol.V
    
    waveOutSetVolume 0, V

End Sub

'Add directory entries to playlist
Public Sub AddDir(BrowseDir As String, ThaForm As Form, SongNames As ListBox, SongPaths As ListBox, ValExt As String)
    
    Dim TmpStr As String, Ext As String, VExt As String
    Dim SubFolderName() As String, Filename As String
    Dim i As Integer, J As Integer, p As Integer
        
    TmpStr = ValidateDir(BrowseDir): If TmpStr = "" Then Exit Sub
    
    'Loop through for subdirectory names and put into array

    ReDim Preserve SubFolderName(i)
    SubFolderName(0) = TmpStr
    i = 1
    J = 0
    
    While J < i
        Filename = Dir(SubFolderName(J), vbDirectory)
        Do Until Filename = ""
            DoEvents
            If (GetAttr(SubFolderName(J) & Filename) And vbDirectory) = vbDirectory Then  ' it represents a directory.
                If Filename <> "." And Filename <> ".." And Filename <> TmpStr Then
                    ReDim Preserve SubFolderName(i)
                    SubFolderName(i) = SubFolderName(J) & Filename & "\"
                    i = i + 1
                End If
            End If
            Filename = Dir
        Loop
        J = J + 1
    Wend
        
    'Loop through sub-folders and add files with matching extensions to playlist
    VExt = UCase$(ValExt)
    J = 0
    While J < i
        Filename = Dir(SubFolderName(J))
        Do Until Filename = ""
            DoEvents
            Ext = UCase$(GetExtension(Filename))
            If InStr(VExt, Ext) > 0 Then
                SongNames.AddItem MakeTitle(GetBaseName(Filename))
                SongPaths.AddItem SubFolderName(J) & Filename
            End If
            Filename = Dir
        Loop
        J = J + 1
    Wend

End Sub
'Display "Browse for folder" window with message header
Public Function GetBrowseDir(ThaForm As Form, Msg As String) As String
            
    GetBrowseDir = vbGetBrowseDirectory(ThaForm.hwnd, Msg)
    
End Function
Public Function vbGetBrowseDirectory(ThaForm As Long, Msg As String) As String

    Dim bi As BROWSEINFO
    Dim IDL As ITEMIDLIST
    
    Dim R As Long, pidl As Long, tmpPath As String, pos As Integer
    
    bi.hOwner = ThaForm
    bi.pidlRoot = 0&
    bi.lpszTitle = Msg
    bi.ulFlags = BIF_RETURNONLYFSDIRS
    
   'get the folder
    pidl = SHBrowseForFolder(bi)
    
    tmpPath = Space$(512)
    R = SHGetPathFromIDList(ByVal pidl, ByVal tmpPath)
      
    If R Then
        pos = InStr(tmpPath, Chr(0))
        tmpPath = Left(tmpPath, pos - 1)
        vbGetBrowseDirectory = ValidateDir(tmpPath)
    Else
        vbGetBrowseDirectory = ""
    End If

End Function

' Add trailing \ to path if needed (except null paths)
Function ValidateDir(ByVal tmpPath As String) As String

    If Right(tmpPath, 1) = "\" Then
        ValidateDir = tmpPath
    Else
        If tmpPath <> "" Then
            ValidateDir = tmpPath & "\"
        Else
            ValidateDir = ""
        End If
    End If

End Function

'Return the Filename part of the filespec
Function GetFileName(ByVal Filename As String) As String
    Dim L As Integer, J As Integer
    
    L = Len(Filename)
    For J = L To 1 Step -1
        If Mid(Filename, J, 1) = "\" Then Exit For
    Next J
    
    GetFileName = Mid(Filename, J + 1)
    
End Function

'Return the Extension part of the filespec
Function GetExtension(ByVal Filename As String) As String
    Dim L As Integer, J As Integer
    
    L = Len(Filename)
    For J = L To 1 Step -1
        If Mid(Filename, J, 1) = "." Then Exit For
    Next J
    
    GetExtension = Mid(Filename, J + 1)
    
End Function

'Return the Path and Filename parts from Filespec
Function GetBaseName(ByVal Filename As String) As String
    Dim L As Integer, J As Integer
    
    L = Len(Filename)
    For J = L To 1 Step -1
        If Mid(Filename, J, 1) = "." Then Exit For
    Next J
    
    GetBaseName = Left(Filename, J - 1)
    
End Function

'Extracts the Path from a filespec
Public Function GetPath(ByVal Filename As String) As String
    Dim p As Integer, J As Integer
    
    p = 0
    For J = Len(Filename) To 1 Step -1
        If Mid(Filename, J, 1) = "\" Then p = J: Exit For
    Next
    If p > 0 Then GetPath = Left$(Filename, p) Else GetPath = ""
    
End Function

' Check if a file exists
Public Function Exists(ByVal Filename As String) As Boolean
      
    On Local Error GoTo ExErr
    
    Exists = False
    If Filename <> "" Then
        If Dir(Filename) <> "" Then Exists = True
    End If
    Exit Function

ExErr:
End Function

'Convert filename to friendly name (remove extra characters etc)
Public Function MakeTitle(ByVal A As String) As String
    Dim p As Integer, L As Integer, SS As Integer
    Dim J As Integer, T As String
    
    p = Len(A): L = p + 1: SS = 1
    For J = 1 To p
        T = Mid(A, J, 1)
        If OptFriendly > 0 Then
            If T = "_" Then Mid(A, J, 1) = " "
            If T = "." Then
                'is it extension or just period in name?
                If J > p - 5 Then L = J Else Mid(A, J, 1) = " "
            End If
        End If
        If T = "\" Then SS = J + 1
    Next J
    
    T = Mid(A, SS, L - SS)
    If OptFriendly > 0 Then
        If Val(T) > 0 Then
            'remove track number
            If Mid(T, 3, 1) = "-" Then T = Mid(T, 4)
            If Mid(T, 3, 2) = " -" Then T = Mid(T, 5)
        End If
    End If
  
    MakeTitle = Trim(T) 'remove spaces
  
End Function

'Lookup in string table using bit(s) in byte as offset
Function LTable$(n As Byte, B1 As Integer, B2 As Integer, W As Integer, A$)
    Dim Power As Integer, V As Integer, J As Integer
    'N=byte to look in, B1=first bit, B2=second bit
    'W=Width of each entry in string, A$=the string table
    V = 0
    For J = B1 To B2
        Power = 2 ^ J
        If (n And Power) = Power Then V = V + Power
    Next J
    V = V \ (2 ^ B1) 'shift
    LTable$ = Trim$(Mid$(A$, V * W + 1, W))
End Function

' Process bitmap and return a region that does not include pixels of the specified color
Public Function GetBitmapRegion(cPicture As StdPicture, cTransparent As Long)

    Dim hRgn As Long, tRgn As Long
    Dim X As Integer, Y As Integer, X0 As Integer
    Dim hDC As Long, BM As BITMAP
    
    hDC = CreateCompatibleDC(0) 'Create a new memory DC, where we will scan the picture
    
    If hDC Then
        SelectObject hDC, cPicture 'Let the new DC select the Picture
        'Get the Picture dimensions and create a new rectangular region
        GetObject cPicture, Len(BM), BM
        hRgn = CreateRectRgn(0, 0, BM.bmWidth, BM.bmHeight)
        
        'Start scanning the picture from top to bottom
        For Y = 0 To BM.bmHeight
            For X = 0 To BM.bmWidth
                'Scan a line of non transparent pixels
                While X <= BM.bmWidth And GetPixel(hDC, X, Y) <> cTransparent
                    X = X + 1
                Wend
                
                X0 = X 'Mark the start of a line of transparent pixels
                
                'Scan a line of transparent pixels
                While X <= BM.bmWidth And GetPixel(hDC, X, Y) = cTransparent
                    X = X + 1
                Wend
                
                'Create a new Region that corresponds to the row of
                'Transparent pixels and then remove it from the main Region
                If X0 < X Then
                    tRgn = CreateRectRgn(X0, Y, X, Y + 1)
                    CombineRgn hRgn, hRgn, tRgn, 4
                    DeleteObject tRgn 'Free the memory used by the new temporary Region
                End If
            Next X
        Next Y
        GetBitmapRegion = hRgn 'Return the memory address to the shaped region
        DeleteObject SelectObject(hDC, cPicture) 'Free memory by deleting the Picture
    End If
    DeleteDC hDC 'Free memory by deleting the created DC
End Function


